diff -Naur openssl-1.0.0q.orig/openssl/asn1.h openssl-1.0.0q/openssl/asn1.h
--- openssl-1.0.0q.orig/openssl/asn1.h	1970-01-01 01:00:00.000000000 +0100
+++ openssl-1.0.0q/openssl/asn1.h	2017-04-25 16:23:40.903797546 +0200
@@ -0,0 +1 @@
+#include "modules/libopeay/crypto/asn1/asn1.h"
diff -Naur openssl-1.0.0q.orig/openssl/asn1_mac.h openssl-1.0.0q/openssl/asn1_mac.h
--- openssl-1.0.0q.orig/openssl/asn1_mac.h	1970-01-01 01:00:00.000000000 +0100
+++ openssl-1.0.0q/openssl/asn1_mac.h	2017-04-25 16:23:40.904797394 +0200
@@ -0,0 +1 @@
+#include "modules/libopeay/crypto/asn1/asn1_mac.h"
diff -Naur openssl-1.0.0q.orig/openssl/asn1t.h openssl-1.0.0q/openssl/asn1t.h
--- openssl-1.0.0q.orig/openssl/asn1t.h	1970-01-01 01:00:00.000000000 +0100
+++ openssl-1.0.0q/openssl/asn1t.h	2017-04-25 16:23:40.904797394 +0200
@@ -0,0 +1 @@
+#include "modules/libopeay/crypto/asn1/asn1t.h"
diff -Naur openssl-1.0.0q.orig/openssl/bio.h openssl-1.0.0q/openssl/bio.h
--- openssl-1.0.0q.orig/openssl/bio.h	1970-01-01 01:00:00.000000000 +0100
+++ openssl-1.0.0q/openssl/bio.h	2017-04-25 16:23:40.904797394 +0200
@@ -0,0 +1 @@
+#include "modules/libopeay/crypto/bio/bio.h"
diff -Naur openssl-1.0.0q.orig/openssl/blowfish.h openssl-1.0.0q/openssl/blowfish.h
--- openssl-1.0.0q.orig/openssl/blowfish.h	1970-01-01 01:00:00.000000000 +0100
+++ openssl-1.0.0q/openssl/blowfish.h	2017-04-25 16:23:40.904797394 +0200
@@ -0,0 +1 @@
+#include "modules/libopeay/crypto/bf/blowfish.h"
diff -Naur openssl-1.0.0q.orig/openssl/bn.h openssl-1.0.0q/openssl/bn.h
--- openssl-1.0.0q.orig/openssl/bn.h	1970-01-01 01:00:00.000000000 +0100
+++ openssl-1.0.0q/openssl/bn.h	2017-04-25 16:23:40.905797242 +0200
@@ -0,0 +1 @@
+#include "modules/libopeay/crypto/bn/bn.h"
diff -Naur openssl-1.0.0q.orig/openssl/buffer.h openssl-1.0.0q/openssl/buffer.h
--- openssl-1.0.0q.orig/openssl/buffer.h	1970-01-01 01:00:00.000000000 +0100
+++ openssl-1.0.0q/openssl/buffer.h	2017-04-25 16:23:40.905797242 +0200
@@ -0,0 +1 @@
+#include "modules/libopeay/crypto/buffer/buffer.h"
diff -Naur openssl-1.0.0q.orig/openssl/camellia.h openssl-1.0.0q/openssl/camellia.h
--- openssl-1.0.0q.orig/openssl/camellia.h	1970-01-01 01:00:00.000000000 +0100
+++ openssl-1.0.0q/openssl/camellia.h	2017-04-25 16:23:40.905797242 +0200
@@ -0,0 +1 @@
+#include "modules/libopeay/crypto/camellia/camellia.h"
diff -Naur openssl-1.0.0q.orig/openssl/cast.h openssl-1.0.0q/openssl/cast.h
--- openssl-1.0.0q.orig/openssl/cast.h	1970-01-01 01:00:00.000000000 +0100
+++ openssl-1.0.0q/openssl/cast.h	2017-04-25 16:23:40.906797369 +0200
@@ -0,0 +1 @@
+#include "modules/libopeay/crypto/cast/cast.h"
diff -Naur openssl-1.0.0q.orig/openssl/cms.h openssl-1.0.0q/openssl/cms.h
--- openssl-1.0.0q.orig/openssl/cms.h	1970-01-01 01:00:00.000000000 +0100
+++ openssl-1.0.0q/openssl/cms.h	2017-04-25 16:23:40.906797369 +0200
@@ -0,0 +1 @@
+#include "modules/libopeay/crypto/cms/cms.h"
diff -Naur openssl-1.0.0q.orig/openssl/comp.h openssl-1.0.0q/openssl/comp.h
--- openssl-1.0.0q.orig/openssl/comp.h	1970-01-01 01:00:00.000000000 +0100
+++ openssl-1.0.0q/openssl/comp.h	2017-04-25 16:23:40.906797369 +0200
@@ -0,0 +1 @@
+#include "modules/libopeay/crypto/comp/comp.h"
diff -Naur openssl-1.0.0q.orig/openssl/conf.h openssl-1.0.0q/openssl/conf.h
--- openssl-1.0.0q.orig/openssl/conf.h	1970-01-01 01:00:00.000000000 +0100
+++ openssl-1.0.0q/openssl/conf.h	2017-04-25 16:23:40.907798055 +0200
@@ -0,0 +1 @@
+#include "modules/libopeay/crypto/conf/conf.h"
diff -Naur openssl-1.0.0q.orig/openssl/conf_api.h openssl-1.0.0q/openssl/conf_api.h
--- openssl-1.0.0q.orig/openssl/conf_api.h	1970-01-01 01:00:00.000000000 +0100
+++ openssl-1.0.0q/openssl/conf_api.h	2017-04-25 16:23:40.907798055 +0200
@@ -0,0 +1 @@
+#include "modules/libopeay/crypto/conf/conf_api.h"
diff -Naur openssl-1.0.0q.orig/openssl/cryptlib.h openssl-1.0.0q/openssl/cryptlib.h
--- openssl-1.0.0q.orig/openssl/cryptlib.h	1970-01-01 01:00:00.000000000 +0100
+++ openssl-1.0.0q/openssl/cryptlib.h	2017-04-25 16:23:40.907798055 +0200
@@ -0,0 +1 @@
+#include "modules/libopeay/crypto/cryptlib.h"
diff -Naur openssl-1.0.0q.orig/openssl/crypto.h openssl-1.0.0q/openssl/crypto.h
--- openssl-1.0.0q.orig/openssl/crypto.h	1970-01-01 01:00:00.000000000 +0100
+++ openssl-1.0.0q/openssl/crypto.h	2017-04-25 16:23:40.907798055 +0200
@@ -0,0 +1 @@
+#include "modules/libopeay/crypto/crypto.h"
diff -Naur openssl-1.0.0q.orig/openssl/des.h openssl-1.0.0q/openssl/des.h
--- openssl-1.0.0q.orig/openssl/des.h	1970-01-01 01:00:00.000000000 +0100
+++ openssl-1.0.0q/openssl/des.h	2017-04-25 16:23:40.908798741 +0200
@@ -0,0 +1 @@
+#include "modules/libopeay/crypto/des/des.h"
diff -Naur openssl-1.0.0q.orig/openssl/des_old.h openssl-1.0.0q/openssl/des_old.h
--- openssl-1.0.0q.orig/openssl/des_old.h	1970-01-01 01:00:00.000000000 +0100
+++ openssl-1.0.0q/openssl/des_old.h	2017-04-25 16:23:40.908798741 +0200
@@ -0,0 +1 @@
+#include "modules/libopeay/crypto/des/des_old.h"
diff -Naur openssl-1.0.0q.orig/openssl/dh.h openssl-1.0.0q/openssl/dh.h
--- openssl-1.0.0q.orig/openssl/dh.h	1970-01-01 01:00:00.000000000 +0100
+++ openssl-1.0.0q/openssl/dh.h	2017-04-25 16:23:40.908798741 +0200
@@ -0,0 +1 @@
+#include "modules/libopeay/crypto/dh/dh.h"
diff -Naur openssl-1.0.0q.orig/openssl/dsa.h openssl-1.0.0q/openssl/dsa.h
--- openssl-1.0.0q.orig/openssl/dsa.h	1970-01-01 01:00:00.000000000 +0100
+++ openssl-1.0.0q/openssl/dsa.h	2017-04-25 16:23:40.909798309 +0200
@@ -0,0 +1 @@
+#include "modules/libopeay/crypto/dsa/dsa.h"
diff -Naur openssl-1.0.0q.orig/openssl/dso.h openssl-1.0.0q/openssl/dso.h
--- openssl-1.0.0q.orig/openssl/dso.h	1970-01-01 01:00:00.000000000 +0100
+++ openssl-1.0.0q/openssl/dso.h	2017-04-25 16:23:40.909798309 +0200
@@ -0,0 +1 @@
+#include "modules/libopeay/crypto/dso/dso.h"
diff -Naur openssl-1.0.0q.orig/openssl/dtls1.h openssl-1.0.0q/openssl/dtls1.h
--- openssl-1.0.0q.orig/openssl/dtls1.h	1970-01-01 01:00:00.000000000 +0100
+++ openssl-1.0.0q/openssl/dtls1.h	2017-04-25 16:23:40.909798309 +0200
@@ -0,0 +1 @@
+#include "modules/libopeay/ssl/dtls1.h"
diff -Naur openssl-1.0.0q.orig/openssl/e_os.h openssl-1.0.0q/openssl/e_os.h
--- openssl-1.0.0q.orig/openssl/e_os.h	1970-01-01 01:00:00.000000000 +0100
+++ openssl-1.0.0q/openssl/e_os.h	2017-04-25 16:23:40.910798716 +0200
@@ -0,0 +1 @@
+#include "modules/libopeay/e_os.h"
diff -Naur openssl-1.0.0q.orig/openssl/e_os2.h openssl-1.0.0q/openssl/e_os2.h
--- openssl-1.0.0q.orig/openssl/e_os2.h	1970-01-01 01:00:00.000000000 +0100
+++ openssl-1.0.0q/openssl/e_os2.h	2017-04-25 16:23:40.910798716 +0200
@@ -0,0 +1 @@
+#include "modules/libopeay/e_os2.h"
diff -Naur openssl-1.0.0q.orig/openssl/ebcdic.h openssl-1.0.0q/openssl/ebcdic.h
--- openssl-1.0.0q.orig/openssl/ebcdic.h	1970-01-01 01:00:00.000000000 +0100
+++ openssl-1.0.0q/openssl/ebcdic.h	2017-04-25 16:23:40.910798716 +0200
@@ -0,0 +1 @@
+#include "modules/libopeay/crypto/ebcdic.h"
diff -Naur openssl-1.0.0q.orig/openssl/ec.h openssl-1.0.0q/openssl/ec.h
--- openssl-1.0.0q.orig/openssl/ec.h	1970-01-01 01:00:00.000000000 +0100
+++ openssl-1.0.0q/openssl/ec.h	2017-04-25 16:23:40.910798716 +0200
@@ -0,0 +1 @@
+#include "modules/libopeay/crypto/ec/ec.h"
diff -Naur openssl-1.0.0q.orig/openssl/ecdh.h openssl-1.0.0q/openssl/ecdh.h
--- openssl-1.0.0q.orig/openssl/ecdh.h	1970-01-01 01:00:00.000000000 +0100
+++ openssl-1.0.0q/openssl/ecdh.h	2017-04-25 16:23:40.911798284 +0200
@@ -0,0 +1 @@
+#include "modules/libopeay/crypto/ecdh/ecdh.h"
diff -Naur openssl-1.0.0q.orig/openssl/ecdsa.h openssl-1.0.0q/openssl/ecdsa.h
--- openssl-1.0.0q.orig/openssl/ecdsa.h	1970-01-01 01:00:00.000000000 +0100
+++ openssl-1.0.0q/openssl/ecdsa.h	2017-04-25 16:23:40.911798284 +0200
@@ -0,0 +1 @@
+#include "modules/libopeay/crypto/ecdsa/ecdsa.h"
diff -Naur openssl-1.0.0q.orig/openssl/engine.h openssl-1.0.0q/openssl/engine.h
--- openssl-1.0.0q.orig/openssl/engine.h	1970-01-01 01:00:00.000000000 +0100
+++ openssl-1.0.0q/openssl/engine.h	2017-04-25 16:23:40.911798284 +0200
@@ -0,0 +1 @@
+#include "modules/libopeay/crypto/engine/engine.h"
diff -Naur openssl-1.0.0q.orig/openssl/err.h openssl-1.0.0q/openssl/err.h
--- openssl-1.0.0q.orig/openssl/err.h	1970-01-01 01:00:00.000000000 +0100
+++ openssl-1.0.0q/openssl/err.h	2017-04-25 16:23:40.912798411 +0200
@@ -0,0 +1 @@
+#include "modules/libopeay/crypto/err/err.h"
diff -Naur openssl-1.0.0q.orig/openssl/evp.h openssl-1.0.0q/openssl/evp.h
--- openssl-1.0.0q.orig/openssl/evp.h	1970-01-01 01:00:00.000000000 +0100
+++ openssl-1.0.0q/openssl/evp.h	2017-04-25 16:23:40.912798411 +0200
@@ -0,0 +1 @@
+#include "modules/libopeay/crypto/evp/evp.h"
diff -Naur openssl-1.0.0q.orig/openssl/ext_dat.h openssl-1.0.0q/openssl/ext_dat.h
--- openssl-1.0.0q.orig/openssl/ext_dat.h	1970-01-01 01:00:00.000000000 +0100
+++ openssl-1.0.0q/openssl/ext_dat.h	2017-04-25 16:23:41.247030276 +0200
@@ -0,0 +1 @@
+#include "modules/libopeay/crypto/x509v3/ext_dat.h"
diff -Naur openssl-1.0.0q.orig/openssl/hmac.h openssl-1.0.0q/openssl/hmac.h
--- openssl-1.0.0q.orig/openssl/hmac.h	1970-01-01 01:00:00.000000000 +0100
+++ openssl-1.0.0q/openssl/hmac.h	2017-04-25 16:23:41.278030305 +0200
@@ -0,0 +1 @@
+#include "modules/libopeay/crypto/hmac/hmac.h"
diff -Naur openssl-1.0.0q.orig/openssl/idea.h openssl-1.0.0q/openssl/idea.h
--- openssl-1.0.0q.orig/openssl/idea.h	1970-01-01 01:00:00.000000000 +0100
+++ openssl-1.0.0q/openssl/idea.h	2017-04-25 16:23:41.278030305 +0200
@@ -0,0 +1 @@
+#include "modules/libopeay/crypto/idea/idea.h"
diff -Naur openssl-1.0.0q.orig/openssl/krb5_asn.h openssl-1.0.0q/openssl/krb5_asn.h
--- openssl-1.0.0q.orig/openssl/krb5_asn.h	1970-01-01 01:00:00.000000000 +0100
+++ openssl-1.0.0q/openssl/krb5_asn.h	2017-04-25 16:23:41.279030153 +0200
@@ -0,0 +1 @@
+#include "modules/libopeay/crypto/krb5/krb5_asn.h"
diff -Naur openssl-1.0.0q.orig/openssl/kssl.h openssl-1.0.0q/openssl/kssl.h
--- openssl-1.0.0q.orig/openssl/kssl.h	1970-01-01 01:00:00.000000000 +0100
+++ openssl-1.0.0q/openssl/kssl.h	2017-04-25 16:23:41.279030153 +0200
@@ -0,0 +1 @@
+#include "modules/libopeay/ssl/kssl.h"
diff -Naur openssl-1.0.0q.orig/openssl/lhash.h openssl-1.0.0q/openssl/lhash.h
--- openssl-1.0.0q.orig/openssl/lhash.h	1970-01-01 01:00:00.000000000 +0100
+++ openssl-1.0.0q/openssl/lhash.h	2017-04-25 16:23:41.280031118 +0200
@@ -0,0 +1 @@
+#include "modules/libopeay/crypto/lhash/lhash.h"
diff -Naur openssl-1.0.0q.orig/openssl/md32_common.h openssl-1.0.0q/openssl/md32_common.h
--- openssl-1.0.0q.orig/openssl/md32_common.h	1970-01-01 01:00:00.000000000 +0100
+++ openssl-1.0.0q/openssl/md32_common.h	2017-04-25 16:23:41.300029470 +0200
@@ -0,0 +1 @@
+#include "modules/libopeay/crypto/md32_common.h"
diff -Naur openssl-1.0.0q.orig/openssl/md4.h openssl-1.0.0q/openssl/md4.h
--- openssl-1.0.0q.orig/openssl/md4.h	1970-01-01 01:00:00.000000000 +0100
+++ openssl-1.0.0q/openssl/md4.h	2017-04-25 16:23:41.301030714 +0200
@@ -0,0 +1 @@
+#include "modules/libopeay/crypto/md4/md4.h"
diff -Naur openssl-1.0.0q.orig/openssl/md5.h openssl-1.0.0q/openssl/md5.h
--- openssl-1.0.0q.orig/openssl/md5.h	1970-01-01 01:00:00.000000000 +0100
+++ openssl-1.0.0q/openssl/md5.h	2017-04-25 16:23:41.301030714 +0200
@@ -0,0 +1 @@
+#include "modules/libopeay/crypto/md5/md5.h"
diff -Naur openssl-1.0.0q.orig/openssl/mdc2.h openssl-1.0.0q/openssl/mdc2.h
--- openssl-1.0.0q.orig/openssl/mdc2.h	1970-01-01 01:00:00.000000000 +0100
+++ openssl-1.0.0q/openssl/mdc2.h	2017-04-25 16:23:41.302030283 +0200
@@ -0,0 +1 @@
+#include "modules/libopeay/crypto/mdc2/mdc2.h"
diff -Naur openssl-1.0.0q.orig/openssl/modes.h openssl-1.0.0q/openssl/modes.h
--- openssl-1.0.0q.orig/openssl/modes.h	1970-01-01 01:00:00.000000000 +0100
+++ openssl-1.0.0q/openssl/modes.h	2017-04-25 16:23:41.306030232 +0200
@@ -0,0 +1 @@
+#include "modules/libopeay/crypto/modes/modes.h"
diff -Naur openssl-1.0.0q.orig/openssl/o_time.h openssl-1.0.0q/openssl/o_time.h
--- openssl-1.0.0q.orig/openssl/o_time.h	1970-01-01 01:00:00.000000000 +0100
+++ openssl-1.0.0q/openssl/o_time.h	2017-04-25 16:23:41.307032874 +0200
@@ -0,0 +1 @@
+#include "modules/libopeay/crypto/o_time.h"
diff -Naur openssl-1.0.0q.orig/openssl/obj_mac.h openssl-1.0.0q/openssl/obj_mac.h
--- openssl-1.0.0q.orig/openssl/obj_mac.h	1970-01-01 01:00:00.000000000 +0100
+++ openssl-1.0.0q/openssl/obj_mac.h	2017-04-25 16:23:41.308030766 +0200
@@ -0,0 +1 @@
+#include "modules/libopeay/crypto/objects/obj_mac.h"
diff -Naur openssl-1.0.0q.orig/openssl/objects.h openssl-1.0.0q/openssl/objects.h
--- openssl-1.0.0q.orig/openssl/objects.h	1970-01-01 01:00:00.000000000 +0100
+++ openssl-1.0.0q/openssl/objects.h	2017-04-25 16:23:41.309030893 +0200
@@ -0,0 +1 @@
+#include "modules/libopeay/crypto/objects/objects.h"
diff -Naur openssl-1.0.0q.orig/openssl/ocsp.h openssl-1.0.0q/openssl/ocsp.h
--- openssl-1.0.0q.orig/openssl/ocsp.h	1970-01-01 01:00:00.000000000 +0100
+++ openssl-1.0.0q/openssl/ocsp.h	2017-04-25 16:23:41.309030893 +0200
@@ -0,0 +1 @@
+#include "modules/libopeay/crypto/ocsp/ocsp.h"
diff -Naur openssl-1.0.0q.orig/openssl/opensslconf.h openssl-1.0.0q/openssl/opensslconf.h
--- openssl-1.0.0q.orig/openssl/opensslconf.h	1970-01-01 01:00:00.000000000 +0100
+++ openssl-1.0.0q/openssl/opensslconf.h	2017-04-25 16:23:41.341030491 +0200
@@ -0,0 +1 @@
+#include "modules/libopeay/crypto/opensslconf.h"
diff -Naur openssl-1.0.0q.orig/openssl/opensslv.h openssl-1.0.0q/openssl/opensslv.h
--- openssl-1.0.0q.orig/openssl/opensslv.h	1970-01-01 01:00:00.000000000 +0100
+++ openssl-1.0.0q/openssl/opensslv.h	2017-04-25 16:23:41.352031051 +0200
@@ -0,0 +1 @@
+#include "modules/libopeay/crypto/opensslv.h"
diff -Naur openssl-1.0.0q.orig/openssl/ossl_typ.h openssl-1.0.0q/openssl/ossl_typ.h
--- openssl-1.0.0q.orig/openssl/ossl_typ.h	1970-01-01 01:00:00.000000000 +0100
+++ openssl-1.0.0q/openssl/ossl_typ.h	2017-04-25 16:23:41.352031051 +0200
@@ -0,0 +1 @@
+#include "modules/libopeay/crypto/ossl_typ.h"
diff -Naur openssl-1.0.0q.orig/openssl/pem.h openssl-1.0.0q/openssl/pem.h
--- openssl-1.0.0q.orig/openssl/pem.h	1970-01-01 01:00:00.000000000 +0100
+++ openssl-1.0.0q/openssl/pem.h	2017-04-25 16:23:41.353030899 +0200
@@ -0,0 +1 @@
+#include "modules/libopeay/crypto/pem/pem.h"
diff -Naur openssl-1.0.0q.orig/openssl/pem2.h openssl-1.0.0q/openssl/pem2.h
--- openssl-1.0.0q.orig/openssl/pem2.h	1970-01-01 01:00:00.000000000 +0100
+++ openssl-1.0.0q/openssl/pem2.h	2017-04-25 16:23:41.354031585 +0200
@@ -0,0 +1 @@
+#include "modules/libopeay/crypto/pem/pem2.h"
diff -Naur openssl-1.0.0q.orig/openssl/pkcs12.h openssl-1.0.0q/openssl/pkcs12.h
--- openssl-1.0.0q.orig/openssl/pkcs12.h	1970-01-01 01:00:00.000000000 +0100
+++ openssl-1.0.0q/openssl/pkcs12.h	2017-04-25 16:23:41.359030544 +0200
@@ -0,0 +1 @@
+#include "modules/libopeay/crypto/pkcs12/pkcs12.h"
diff -Naur openssl-1.0.0q.orig/openssl/pkcs7.h openssl-1.0.0q/openssl/pkcs7.h
--- openssl-1.0.0q.orig/openssl/pkcs7.h	1970-01-01 01:00:00.000000000 +0100
+++ openssl-1.0.0q/openssl/pkcs7.h	2017-04-25 16:23:41.359030544 +0200
@@ -0,0 +1 @@
+#include "modules/libopeay/crypto/pkcs7/pkcs7.h"
diff -Naur openssl-1.0.0q.orig/openssl/pqueue.h openssl-1.0.0q/openssl/pqueue.h
--- openssl-1.0.0q.orig/openssl/pqueue.h	1970-01-01 01:00:00.000000000 +0100
+++ openssl-1.0.0q/openssl/pqueue.h	2017-04-25 16:23:41.360030671 +0200
@@ -0,0 +1 @@
+#include "modules/libopeay/crypto/pqueue/pqueue.h"
diff -Naur openssl-1.0.0q.orig/openssl/rand.h openssl-1.0.0q/openssl/rand.h
--- openssl-1.0.0q.orig/openssl/rand.h	1970-01-01 01:00:00.000000000 +0100
+++ openssl-1.0.0q/openssl/rand.h	2017-04-25 16:23:41.360030671 +0200
@@ -0,0 +1 @@
+#include "modules/libopeay/crypto/rand/rand.h"
diff -Naur openssl-1.0.0q.orig/openssl/rc2.h openssl-1.0.0q/openssl/rc2.h
--- openssl-1.0.0q.orig/openssl/rc2.h	1970-01-01 01:00:00.000000000 +0100
+++ openssl-1.0.0q/openssl/rc2.h	2017-04-25 16:23:41.361031078 +0200
@@ -0,0 +1 @@
+#include "modules/libopeay/crypto/rc2/rc2.h"
diff -Naur openssl-1.0.0q.orig/openssl/rc4.h openssl-1.0.0q/openssl/rc4.h
--- openssl-1.0.0q.orig/openssl/rc4.h	1970-01-01 01:00:00.000000000 +0100
+++ openssl-1.0.0q/openssl/rc4.h	2017-04-25 16:23:41.361031078 +0200
@@ -0,0 +1 @@
+#include "modules/libopeay/crypto/rc4/rc4.h"
diff -Naur openssl-1.0.0q.orig/openssl/rc5.h openssl-1.0.0q/openssl/rc5.h
--- openssl-1.0.0q.orig/openssl/rc5.h	1970-01-01 01:00:00.000000000 +0100
+++ openssl-1.0.0q/openssl/rc5.h	2017-04-25 16:23:41.362030646 +0200
@@ -0,0 +1 @@
+#include "modules/libopeay/crypto/rc5/rc5.h"
diff -Naur openssl-1.0.0q.orig/openssl/ripemd.h openssl-1.0.0q/openssl/ripemd.h
--- openssl-1.0.0q.orig/openssl/ripemd.h	1970-01-01 01:00:00.000000000 +0100
+++ openssl-1.0.0q/openssl/ripemd.h	2017-04-25 16:23:41.362030646 +0200
@@ -0,0 +1 @@
+#include "modules/libopeay/crypto/ripemd/ripemd.h"
diff -Naur openssl-1.0.0q.orig/openssl/rsa.h openssl-1.0.0q/openssl/rsa.h
--- openssl-1.0.0q.orig/openssl/rsa.h	1970-01-01 01:00:00.000000000 +0100
+++ openssl-1.0.0q/openssl/rsa.h	2017-04-25 16:23:41.362030646 +0200
@@ -0,0 +1 @@
+#include "modules/libopeay/crypto/rsa/rsa.h"
diff -Naur openssl-1.0.0q.orig/openssl/safestack.h openssl-1.0.0q/openssl/safestack.h
--- openssl-1.0.0q.orig/openssl/safestack.h	1970-01-01 01:00:00.000000000 +0100
+++ openssl-1.0.0q/openssl/safestack.h	2017-04-25 16:23:41.363030494 +0200
@@ -0,0 +1 @@
+#include "modules/libopeay/crypto/stack/safestack.h"
diff -Naur openssl-1.0.0q.orig/openssl/seed.h openssl-1.0.0q/openssl/seed.h
--- openssl-1.0.0q.orig/openssl/seed.h	1970-01-01 01:00:00.000000000 +0100
+++ openssl-1.0.0q/openssl/seed.h	2017-04-25 16:23:41.363030494 +0200
@@ -0,0 +1 @@
+#include "modules/libopeay/crypto/seed/seed.h"
diff -Naur openssl-1.0.0q.orig/openssl/sha.h openssl-1.0.0q/openssl/sha.h
--- openssl-1.0.0q.orig/openssl/sha.h	1970-01-01 01:00:00.000000000 +0100
+++ openssl-1.0.0q/openssl/sha.h	2017-04-25 16:23:41.364030341 +0200
@@ -0,0 +1 @@
+#include "modules/libopeay/crypto/sha/sha.h"
diff -Naur openssl-1.0.0q.orig/openssl/ssl.h openssl-1.0.0q/openssl/ssl.h
--- openssl-1.0.0q.orig/openssl/ssl.h	1970-01-01 01:00:00.000000000 +0100
+++ openssl-1.0.0q/openssl/ssl.h	2017-04-25 16:23:41.364030341 +0200
@@ -0,0 +1 @@
+#include "modules/libopeay/ssl/ssl.h"
diff -Naur openssl-1.0.0q.orig/openssl/ssl2.h openssl-1.0.0q/openssl/ssl2.h
--- openssl-1.0.0q.orig/openssl/ssl2.h	1970-01-01 01:00:00.000000000 +0100
+++ openssl-1.0.0q/openssl/ssl2.h	2017-04-25 16:23:41.364030341 +0200
@@ -0,0 +1 @@
+#include "modules/libopeay/ssl/ssl2.h"
diff -Naur openssl-1.0.0q.orig/openssl/ssl23.h openssl-1.0.0q/openssl/ssl23.h
--- openssl-1.0.0q.orig/openssl/ssl23.h	1970-01-01 01:00:00.000000000 +0100
+++ openssl-1.0.0q/openssl/ssl23.h	2017-04-25 16:23:41.365030748 +0200
@@ -0,0 +1 @@
+#include "modules/libopeay/ssl/ssl23.h"
diff -Naur openssl-1.0.0q.orig/openssl/ssl3.h openssl-1.0.0q/openssl/ssl3.h
--- openssl-1.0.0q.orig/openssl/ssl3.h	1970-01-01 01:00:00.000000000 +0100
+++ openssl-1.0.0q/openssl/ssl3.h	2017-04-25 16:23:41.365030748 +0200
@@ -0,0 +1 @@
+#include "modules/libopeay/ssl/ssl3.h"
diff -Naur openssl-1.0.0q.orig/openssl/stack.h openssl-1.0.0q/openssl/stack.h
--- openssl-1.0.0q.orig/openssl/stack.h	1970-01-01 01:00:00.000000000 +0100
+++ openssl-1.0.0q/openssl/stack.h	2017-04-25 16:23:41.365030748 +0200
@@ -0,0 +1 @@
+#include "modules/libopeay/crypto/stack/stack.h"
diff -Naur openssl-1.0.0q.orig/openssl/symhacks.h openssl-1.0.0q/openssl/symhacks.h
--- openssl-1.0.0q.orig/openssl/symhacks.h	1970-01-01 01:00:00.000000000 +0100
+++ openssl-1.0.0q/openssl/symhacks.h	2017-04-25 16:23:41.366030596 +0200
@@ -0,0 +1 @@
+#include "modules/libopeay/crypto/symhacks.h"
diff -Naur openssl-1.0.0q.orig/openssl/tls1.h openssl-1.0.0q/openssl/tls1.h
--- openssl-1.0.0q.orig/openssl/tls1.h	1970-01-01 01:00:00.000000000 +0100
+++ openssl-1.0.0q/openssl/tls1.h	2017-04-25 16:23:41.366030596 +0200
@@ -0,0 +1 @@
+#include "modules/libopeay/ssl/tls1.h"
diff -Naur openssl-1.0.0q.orig/openssl/ts.h openssl-1.0.0q/openssl/ts.h
--- openssl-1.0.0q.orig/openssl/ts.h	1970-01-01 01:00:00.000000000 +0100
+++ openssl-1.0.0q/openssl/ts.h	2017-04-25 16:23:41.366030596 +0200
@@ -0,0 +1 @@
+#include "modules/libopeay/crypto/ts/ts.h"
diff -Naur openssl-1.0.0q.orig/openssl/txt_db.h openssl-1.0.0q/openssl/txt_db.h
--- openssl-1.0.0q.orig/openssl/txt_db.h	1970-01-01 01:00:00.000000000 +0100
+++ openssl-1.0.0q/openssl/txt_db.h	2017-04-25 16:23:41.366030596 +0200
@@ -0,0 +1 @@
+#include "modules/libopeay/crypto/txt_db/txt_db.h"
diff -Naur openssl-1.0.0q.orig/openssl/ui.h openssl-1.0.0q/openssl/ui.h
--- openssl-1.0.0q.orig/openssl/ui.h	1970-01-01 01:00:00.000000000 +0100
+++ openssl-1.0.0q/openssl/ui.h	2017-04-25 16:23:41.367030164 +0200
@@ -0,0 +1 @@
+#include "modules/libopeay/crypto/ui/ui.h"
diff -Naur openssl-1.0.0q.orig/openssl/ui_compat.h openssl-1.0.0q/openssl/ui_compat.h
--- openssl-1.0.0q.orig/openssl/ui_compat.h	1970-01-01 01:00:00.000000000 +0100
+++ openssl-1.0.0q/openssl/ui_compat.h	2017-04-25 16:23:41.367030164 +0200
@@ -0,0 +1 @@
+#include "modules/libopeay/crypto/ui/ui_compat.h"
diff -Naur openssl-1.0.0q.orig/openssl/whrlpool.h openssl-1.0.0q/openssl/whrlpool.h
--- openssl-1.0.0q.orig/openssl/whrlpool.h	1970-01-01 01:00:00.000000000 +0100
+++ openssl-1.0.0q/openssl/whrlpool.h	2017-04-25 16:23:41.367030164 +0200
@@ -0,0 +1 @@
+#include "modules/libopeay/crypto/whrlpool/whrlpool.h"
diff -Naur openssl-1.0.0q.orig/openssl/x509.h openssl-1.0.0q/openssl/x509.h
--- openssl-1.0.0q.orig/openssl/x509.h	1970-01-01 01:00:00.000000000 +0100
+++ openssl-1.0.0q/openssl/x509.h	2017-04-25 16:23:41.368030012 +0200
@@ -0,0 +1 @@
+#include "modules/libopeay/crypto/x509/x509.h"
diff -Naur openssl-1.0.0q.orig/openssl/x509_vfy.h openssl-1.0.0q/openssl/x509_vfy.h
--- openssl-1.0.0q.orig/openssl/x509_vfy.h	1970-01-01 01:00:00.000000000 +0100
+++ openssl-1.0.0q/openssl/x509_vfy.h	2017-04-25 16:23:41.368030012 +0200
@@ -0,0 +1 @@
+#include "modules/libopeay/crypto/x509/x509_vfy.h"
diff -Naur openssl-1.0.0q.orig/openssl/x509v3.h openssl-1.0.0q/openssl/x509v3.h
--- openssl-1.0.0q.orig/openssl/x509v3.h	1970-01-01 01:00:00.000000000 +0100
+++ openssl-1.0.0q/openssl/x509v3.h	2017-04-25 16:23:41.368030012 +0200
@@ -0,0 +1 @@
+#include "modules/libopeay/crypto/x509v3/x509v3.h"
diff -Naur openssl-1.0.0q.orig/selftest/BIGNUM.ot openssl-1.0.0q/selftest/BIGNUM.ot
--- openssl-1.0.0q.orig/selftest/BIGNUM.ot	1970-01-01 01:00:00.000000000 +0100
+++ openssl-1.0.0q/selftest/BIGNUM.ot	2017-04-25 16:23:41.369029860 +0200
@@ -0,0 +1,63 @@
+/* -*- Mode: c++; tab-width: 4; indent-tabs-mode: t; c-basic-offset: 4 -*-
+**
+** Copyright (C) 2012-2012 Opera Software AS.  All rights reserved.
+**
+** This file is part of the Opera web browser.  It may not be distributed
+** under any circumstances.
+*/
+
+/**
+ * @file BIGNUM.ot
+ *
+ * Selftests for OpenSSL BIGNUM functionality.
+ *
+ * @author Alexei Khlebnikov <alexeik@opera.com>
+ *
+ */
+
+group "libopeay.bignum";
+require CRYPTO_CERTIFICATE_VERIFICATION_USE_CORE_IMPLEMENTATION;
+
+language c++;
+
+include "modules/libopeay/openssl/cryptlib.h";
+include "modules/libopeay/openssl/bn.h";
+
+global
+{
+}
+
+test("BN_new, BN_free")
+{
+	verify(!ERR_peek_error());
+
+	BIGNUM* bn = BN_new();
+	verify(bn);
+	BN_free(bn);
+
+	verify(!ERR_peek_error());
+}
+finally
+{
+	ERR_clear_error();
+}
+
+test("BN_num_bytes(new BIGNUM)")
+{
+	verify(!ERR_peek_error());
+
+	BIGNUM* bn = BN_new();
+	verify(bn);
+
+	int num_bytes = BN_num_bytes(bn);
+	BN_free(bn);
+
+	output("BN_num_bytes() == %i ... ", num_bytes);
+	verify(num_bytes == 0);
+
+	verify(!ERR_peek_error());
+}
+finally
+{
+	ERR_clear_error();
+}
diff -Naur openssl-1.0.0q.orig/selftest/EVP_PKEY.ot openssl-1.0.0q/selftest/EVP_PKEY.ot
--- openssl-1.0.0q.orig/selftest/EVP_PKEY.ot	1970-01-01 01:00:00.000000000 +0100
+++ openssl-1.0.0q/selftest/EVP_PKEY.ot	2017-04-25 16:23:41.370029987 +0200
@@ -0,0 +1,282 @@
+/* -*- Mode: c++; tab-width: 4; indent-tabs-mode: t; c-basic-offset: 4 -*-
+**
+** Copyright (C) 2011-2012 Opera Software AS.  All rights reserved.
+**
+** This file is part of the Opera web browser.  It may not be distributed
+** under any circumstances.
+*/
+
+/**
+ * @file EVP_PKEY.ot
+ *
+ * Selftests for OpenSSL EVP_PKEY functionality.
+ *
+ * @author Alexei Khlebnikov <alexeik@opera.com>
+ *
+ */
+
+group "libopeay.evp_pkey";
+require CRYPTO_CERTIFICATE_VERIFICATION_USE_CORE_IMPLEMENTATION;
+
+language c++;
+
+include "modules/libopeay/openssl/cryptlib.h";
+
+include "modules/libopeay/addon/libopeay_util.h";
+include "modules/libopeay/openssl/bn.h";
+include "modules/libopeay/openssl/dh.h";
+include "modules/libopeay/openssl/dsa.h";
+include "modules/libopeay/openssl/evp.h";
+include "modules/libopeay/openssl/rsa.h";
+
+
+global
+{
+}
+
+test("EVP_PKEY_new, EVP_PKEY_free")
+{
+	verify(!ERR_peek_error());
+
+	EVP_PKEY* pkey = EVP_PKEY_new();
+	verify(pkey);
+	EVP_PKEY_free(pkey);
+
+	verify(!ERR_peek_error());
+}
+finally
+{
+	ERR_clear_error();
+}
+
+test("EVP_PKEY_CTX_new_id, EVP_PKEY_CTX_free")
+{
+	verify(!ERR_peek_error());
+
+	EVP_PKEY_CTX* ctx = EVP_PKEY_CTX_new_id(EVP_PKEY_RSA, NULL);
+	verify(ctx);
+	EVP_PKEY_CTX_free(ctx);
+
+	verify(!ERR_peek_error());
+}
+finally
+{
+	ERR_clear_error();
+}
+
+test("EVP_PKEY_type(new EVP_PKEY)")
+{
+	verify(!ERR_peek_error());
+
+	EVP_PKEY* pkey = EVP_PKEY_new();
+	verify(pkey);
+
+	int pkey_type = pkey->type;
+	int pkey_type_complicated = EVP_PKEY_type(pkey->type);
+	int pkey_type_id = EVP_PKEY_id(pkey);
+	EVP_PKEY_free(pkey);
+
+	output("EVP_PKEY_type() == %s ... ", EVP_PKEY_type_name(pkey_type));
+	verify(pkey_type == EVP_PKEY_NONE);
+	verify(pkey_type == pkey_type_complicated);
+	verify(pkey_type == pkey_type_id);
+
+	verify(!ERR_peek_error());
+}
+finally
+{
+	ERR_clear_error();
+}
+
+
+table evp_pkey_types(const char* pkey_type_name, int pkey_type)
+{
+	// This list is taken from modules/libopeay/crypto/evp/evp.h.
+	{ "EVP_PKEY_RSA",  EVP_PKEY_RSA  },
+	{ "EVP_PKEY_RSA2", EVP_PKEY_RSA2 },
+	{ "EVP_PKEY_DSA",  EVP_PKEY_DSA  },
+	{ "EVP_PKEY_DSA1", EVP_PKEY_DSA1 },
+	{ "EVP_PKEY_DSA2", EVP_PKEY_DSA2 },
+	{ "EVP_PKEY_DSA3", EVP_PKEY_DSA3 },
+	{ "EVP_PKEY_DSA4", EVP_PKEY_DSA4 },
+	{ "EVP_PKEY_DH",   EVP_PKEY_DH   },
+	// Elliptic curves are not supported so far.
+	// { "EVP_PKEY_EC",   EVP_PKEY_EC   },
+	{ "EVP_PKEY_HMAC", EVP_PKEY_HMAC }
+}
+
+subtest find_pkey_type(int pkey_type)
+{
+	verify(!ERR_peek_error());
+	const EVP_PKEY_ASN1_METHOD* ameth = EVP_PKEY_asn1_find(NULL, pkey_type);
+	verify(ameth);
+	verify(!ERR_peek_error());
+}
+finally
+{
+	ERR_clear_error();
+}
+
+foreach (pkey_type_name, pkey_type) from evp_pkey_types
+{
+	test("EVP_PKEY_asn1_find, " pkey_type_name)
+	{
+		find_pkey_type(pkey_type);
+	}
+}
+
+test("EVP_PKEY_asn1_find, EVP_PKEY_EC is not supported")
+{
+	verify(!ERR_peek_error());
+	const EVP_PKEY_ASN1_METHOD* ameth = EVP_PKEY_asn1_find(NULL, EVP_PKEY_EC);
+	verify(!ameth);
+	verify(!ERR_peek_error());
+}
+
+
+// This test shouldn't cause memleaks.
+test("EVP_PKEY_free deallocates assigned RSA key")
+{
+	// Variables that are accessed in finally {} block,
+	// must be declared in the first lines of the test().
+	RSA*      rsa  = NULL;
+	EVP_PKEY* pkey = NULL;
+
+	verify(!ERR_peek_error());
+
+	rsa = RSA_new();
+	verify(rsa);
+
+	rsa->n    = BN_new();
+	rsa->e    = BN_new();
+	rsa->d    = BN_new();
+	rsa->p    = BN_new();
+	rsa->q    = BN_new();
+	rsa->dmp1 = BN_new();
+	rsa->iqmp = BN_new();
+
+	pkey = EVP_PKEY_new();
+	verify(pkey);
+
+	int err = EVP_PKEY_assign_RSA(pkey, rsa);
+	verify(err == 1);
+	// Now pkey owns rsa and must deallocate it.
+	rsa = NULL;
+
+	verify(pkey->type == EVP_PKEY_RSA);
+
+	verify(!ERR_peek_error());
+}
+finally
+{
+	EVP_PKEY_free(pkey);
+	RSA_free(rsa);
+	ERR_clear_error();
+}
+
+// This test shouldn't cause memleaks.
+test("EVP_PKEY_free deallocates assigned DSA key")
+{
+	// Variables that are accessed in finally {} block,
+	// must be declared in the first lines of the test().
+	DSA*      dsa  = NULL;
+	EVP_PKEY* pkey = NULL;
+
+	verify(!ERR_peek_error());
+
+	dsa = DSA_new();
+	verify(dsa);
+
+	dsa->p        = BN_new();
+	dsa->q        = BN_new();
+	dsa->g        = BN_new();
+	dsa->pub_key  = BN_new();
+	dsa->priv_key = BN_new();
+
+	pkey = EVP_PKEY_new();
+	verify(pkey);
+
+	int err = EVP_PKEY_assign_DSA(pkey, dsa);
+	verify(err == 1);
+	// Now pkey owns dsa and must deallocate it.
+	dsa = NULL;
+
+	verify(pkey->type == EVP_PKEY_DSA);
+
+	verify(!ERR_peek_error());
+}
+finally
+{
+	EVP_PKEY_free(pkey);
+	DSA_free(dsa);
+	ERR_clear_error();
+}
+
+// This test shouldn't cause memleaks.
+test("EVP_PKEY_free deallocates assigned DH  key")
+{
+	// Variables that are accessed in finally {} block,
+	// must be declared in the first lines of the test().
+	DH*       dh   = NULL;
+	EVP_PKEY* pkey = NULL;
+
+	verify(!ERR_peek_error());
+
+	dh = DH_new();
+	verify(dh);
+
+	dh->p        = BN_new();
+	dh->q        = BN_new();
+	dh->pub_key  = BN_new();
+	dh->priv_key = BN_new();
+
+	pkey = EVP_PKEY_new();
+	verify(pkey);
+
+	int err = EVP_PKEY_assign_DH(pkey, dh);
+	verify(err == 1);
+	// Now pkey owns dh and must deallocate it.
+	dh = NULL;
+
+	verify(pkey->type == EVP_PKEY_DH);
+
+	verify(!ERR_peek_error());
+}
+finally
+{
+	EVP_PKEY_free(pkey);
+	DH_free(dh);
+	ERR_clear_error();
+}
+
+
+test("EVP_PKEY_keygen, EVP_PKEY_RSA")
+{
+	EVP_PKEY_CTX* ctx = NULL;
+	EVP_PKEY*    pkey = NULL;
+	verify(!ERR_peek_error());
+
+	ctx = EVP_PKEY_CTX_new_id(EVP_PKEY_RSA, NULL);
+	verify(ctx);
+
+	int err = EVP_PKEY_keygen_init(ctx);
+	verify(err > 0);
+
+	// 512 bit key length is chosen for speed.
+	err = EVP_PKEY_CTX_set_rsa_keygen_bits(ctx, 512);
+	verify(err > 0);
+
+	// Generate the key.
+	err = EVP_PKEY_keygen(ctx, &pkey);
+	verify(err > 0);
+	verify(pkey);
+	verify(pkey->ameth);
+
+	verify(!ERR_peek_error());
+}
+finally
+{
+	EVP_PKEY_free(pkey);
+	EVP_PKEY_CTX_free(ctx);
+	ERR_clear_error();
+}
diff -Naur openssl-1.0.0q.orig/selftest/TestCA/01-gen-ca.sh openssl-1.0.0q/selftest/TestCA/01-gen-ca.sh
--- openssl-1.0.0q.orig/selftest/TestCA/01-gen-ca.sh	1970-01-01 01:00:00.000000000 +0100
+++ openssl-1.0.0q/selftest/TestCA/01-gen-ca.sh	2017-04-25 16:23:41.370029987 +0200
@@ -0,0 +1,12 @@
+#!/bin/sh -v
+
+rm -rf ca-data keys reqs certs crls
+mkdir  ca-data keys reqs certs crls
+mkdir  ca-data/certs
+
+echo -n   >ca-data/index.txt
+echo "01" >ca-data/serial
+echo "01" >ca-data/crlnumber
+
+openssl genrsa -out ca-data/cakey.pem 2048
+openssl req -new -x509 -subj "/CN=Libopeay test CA/O=Opera/ST=Oslo/C=NO" -days 3650 -key ca-data/cakey.pem -sha1 -out ca-data/cacert.pem -text
diff -Naur openssl-1.0.0q.orig/selftest/TestCA/02-gen-cert1.sh openssl-1.0.0q/selftest/TestCA/02-gen-cert1.sh
--- openssl-1.0.0q.orig/selftest/TestCA/02-gen-cert1.sh	1970-01-01 01:00:00.000000000 +0100
+++ openssl-1.0.0q/selftest/TestCA/02-gen-cert1.sh	2017-04-25 16:23:41.371029834 +0200
@@ -0,0 +1,6 @@
+#!/bin/sh -v
+
+openssl genrsa -out keys/key1.pem 2048
+openssl req -new -subj "/CN=Libopeay test cert 1/O=Opera/ST=Oslo/C=NO" -key keys/key1.pem -sha1 -out reqs/req1.pem -text
+
+openssl ca -batch -config openssl.cnf -in reqs/req1.pem -out certs/cert1.pem -days 3650
diff -Naur openssl-1.0.0q.orig/selftest/TestCA/03-gen-cert2.sh openssl-1.0.0q/selftest/TestCA/03-gen-cert2.sh
--- openssl-1.0.0q.orig/selftest/TestCA/03-gen-cert2.sh	1970-01-01 01:00:00.000000000 +0100
+++ openssl-1.0.0q/selftest/TestCA/03-gen-cert2.sh	2017-04-25 16:23:41.371029834 +0200
@@ -0,0 +1,6 @@
+#!/bin/sh -v
+
+openssl genrsa -out keys/key2.pem 2048
+openssl req -new -subj "/CN=Libopeay test cert 2/O=Opera/ST=Oslo/C=NO" -key keys/key2.pem -sha1 -out reqs/req2.pem -text
+
+openssl ca -batch -config openssl.cnf -in reqs/req2.pem -out certs/cert2.pem -days 3650
diff -Naur openssl-1.0.0q.orig/selftest/TestCA/04-gen-crl1.sh openssl-1.0.0q/selftest/TestCA/04-gen-crl1.sh
--- openssl-1.0.0q.orig/selftest/TestCA/04-gen-crl1.sh	1970-01-01 01:00:00.000000000 +0100
+++ openssl-1.0.0q/selftest/TestCA/04-gen-crl1.sh	2017-04-25 16:23:41.371029834 +0200
@@ -0,0 +1,4 @@
+#!/bin/sh -v
+
+openssl ca -batch -config openssl.cnf -gencrl -crldays 3650 | \
+	openssl crl -out crls/crl1.pem -text
